#!/usr/bin/env bash

# Make sure variables exist
debug=""
today=""
yesterday=""
batchsize=""
importstatus=""

# Parse CLI arguments and assign to variables, e.g. --debug true assigns $debug to true
while [ $# -gt 0 ]; do
	if [[ $1 == "--"* ]]; then
		v="${1/--/}"
		declare "$v"="$2"
		shift
	fi
	shift
done

# Import structured logger
. logger.sh

set -e

# Time between batches
SLEEP_TIME="${1:-1}"

# Importing properties
echo "Importing properties generated by diff..." | json_logger INFO
node -e "require('./import-properties.js')('$DATADIR/properties.json', '$debug');"

echo "Resetting and generating substatement files..." | json_logger INFO
rm -rf "$DATADIR"/sub
mkdir "$DATADIR"/sub
split -a 5 -l "$batchsize" "$DATADIR/statements.sql" "$DATADIR/sub/query_split_"

if [ "$debug" != "true" ]; then
	rm "$DATADIR"/statements.sql
fi

# Rename the split files to add the .sql suffix
find "$DATADIR/sub" -type f -name "query_split_*" -exec mv {} {}.sql \;

# Get the whole batch count and get the number of batches for logging later.
# Even if only a subset will be run, the script is deterministic and all files have
# to be generated regardless.
# TODO: Fix the shellcheck issue
# shellcheck disable=SC2207
filelist=($(find "$DATADIR"/sub/ -type f))
echo "batch_count:${#filelist[@]}" >> "$DATADIR/job.info"

if [[ $importstatus != 'STARTED' ]] && [ -n "$yesterday" ] && [ -n "$today" ]; then
	batches=$(node -e "require('./import-status-utils.js').getBatches('$importstatus');")

	# If retrying a previously failed import, only operate on its batches
	if [ "$(echo "$batches" | jq -c '.include | length')" -gt 0 ]; then
		includelist=()
		for batch in $(echo "$batches" | jq -c '.include[]'); do
			# TODO: Fix the shellcheck issue
			# shellcheck disable=SC2207
			includelist+=($(echo "$batch" | jq -r .))
		done

		filelist=("${includelist[@]}")
	fi

	# If resuming an existing import, exclude already completed batches
	if [ "$(echo "$batches" | jq -c '.exclude | length')" -gt 0 ]; then
		for batch in $(echo "$batches" | jq -c '.exclude[]'); do
			batch=$(echo "$batch" | jq -r .)
			filelist=("${filelist[@]/$batch/}")
		done
	fi
fi

# TODO: Fix the shellcheck issue.
# shellcheck disable=SC2068
for file in ${filelist[@]}; do
	echo "Importing $file..." | json_logger INFO
	if [ -f "$file" ]; then
		# Update the batch status if this was a retry
		if [[ $importstatus == 'ERROR' ]]; then
			node -e "require('./import-status-utils.js').updateBatchStatus('$file', '$yesterday', '$today', 'ERROR');"
		fi
		# Update the batch status if this was a restart
		if [[ $importstatus == 'INCOMPLETE' ]]; then
			node -e "require('./import-status-utils.js').updateBatchStatus('$file', '$yesterday', '$today', 'STARTED');"
		fi
		node -e "require('./update-db.js')('$file');"
		sleep "$SLEEP_TIME"
		if [ "$debug" != "true" ]; then
			rm "$file"
		fi
	fi
done

echo "Cleaning up..." | json_logger INFO
if [ "$debug" != "true" ]; then
	rm "$DATADIR"/job.info
	rm -rf "$DATADIR"/sub
fi

echo "Done!" | json_logger INFO
